﻿using System;
using System.Management;

namespace TestProject;

/// <summary>
/// 프로그램
/// </summary>
class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region NVIDIA GPU 설치 여부 구하기 - IsInstalledNvidiaGPU()

    /// <summary>
    /// NVIDIA GPU 설치 여부 구하기
    /// </summary>
    /// <returns>NVIDIA GPU 설치 여부</returns>
    private static bool IsInstalledNvidiaGPU()
    {
        using ManagementObjectSearcher managementObjectSearcher = new("SELECT * FROM Win32_VideoController");

        foreach(ManagementObject managementObject in managementObjectSearcher.Get())
        {
            string name = managementObject["Name"] as string;

            if(!string.IsNullOrEmpty(name) && name.ToLower().Contains("nvidia"))
            {
                return true;
            }
        }

        return false;
    }

    #endregion
    #region 프로그램 시작하기 - Main()

    /// <summary>
    /// 프로그램 시작하기
    /// </summary>
    private static void Main()
    {
        bool isInstalledNvidiaGPU = IsInstalledNvidiaGPU();

        Console.WriteLine(isInstalledNvidiaGPU ? "NVIDIA GPU가 설치되어 있습니다." : "NVIDIA GPU가 설치되어 있지 않습니다.");
    }

    #endregion
}